<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'rulecode',
    label: '规则编码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'rariable',
    label: '变量名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'valuestr',
    label: '变量值',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'attribute1',
    label: '变量描述',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'attribute2',
    label: '主键',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'organCode',
    label: '机构号',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'lawerMan',
    label: '法人代码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'userId',
    label: '用户名',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'status',
    label: '审核状态',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

